"
COPYRIGHT (c) 2021 LabWare
"
"{ Package: 'stx:goodies/monticello/tonel' }"

"{ NameSpace: Smalltalk }"

TonelFileUtils subclass:#TonelFileUtilsStX
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SCM-Monticello-Tonel-Core'
!

!TonelFileUtilsStX class methodsFor:'documentation'!

copyright
"
COPYRIGHT (c) 2021 LabWare


"
! !

!TonelFileUtilsStX class methodsFor:'utilities'!

default
    "superclass TonelFileUtils class says that I am responsible to implement this method"

    ^ self shouldImplement
!

deleteAll: aDirectory
    ^ aDirectory directoryContentsAsFilenamesDo:[:each|each recursiveRemove]

    "Modified: / 09-07-2020 / 21:25:35 / Jan Vrany <jan.vrany@labware.com>"
!

directoryExists: aDirectory
    ^ aDirectory isDirectory
!

directoryFromPath:directoryPath
    "superclass TonelFileUtils class says that I am responsible to implement this method"

    ^ self shouldImplement
!

directoryFromPath: directoryPath relativeTo: aDirectory
    ^ aDirectory asFilename / directoryPath

    "Modified: / 09-07-2020 / 23:20:33 / Jan Vrany <jan.vrany@labware.com>"
!

directoryName:aDirectory
    ^ aDirectory baseName

    "Modified: / 15-03-2021 / 14:41:49 / Jan Vrany <jan.vrany@labware.com>"
!

directoryPathString:aDirectory
    "superclass TonelFileUtils class says that I am responsible to implement this method"

    ^ self shouldImplement
!

ensureFilePathExists:fileNameOrPath relativeTo:aDirectory
    "superclass TonelFileUtils class says that I am responsible to implement this method"

    ^ self shouldImplement
!

fileName:aDirectory
    ^ aDirectory asFilename baseName

    "Modified: / 04-06-2019 / 12:14:00 / Jan Vrany <jan.vrany@fit.cvut.cz>"
    "Modified (comment): / 10-03-2021 / 10:50:10 / Jan Vrany <jan.vrany@labware.com>"
!

filePathExists: filePath relativeTo: aDirectory
    ^ (aDirectory asFilename / filePath ) isRegularFile

    "Modified: / 09-07-2020 / 23:04:32 / Jan Vrany <jan.vrany@labware.com>"
!

parentDirectoryOf: aDirectory
    ^ aDirectory directory

    "Modified: / 23-12-2020 / 13:18:50 / Jan Vrany <jan.vrany@labware.com>"
!

pathNameDelimiter
    "superclass TonelFileUtils class says that I am responsible to implement this method"

    ^ self shouldImplement
!

readStreamFor: filePath do: aBlock
    ^ filePath asFileReference
        readStreamDo: [ :fileStream | 
            | stream |
            stream := ReadStream on: fileStream contents asString.
            stream reset.
            aBlock value: stream ]
!

readStreamFor:filePath in:aDirectory do:aBlock
    "superclass TonelFileUtils class says that I am responsible to implement this method"

    ^ self shouldImplement
!

resolvePath:path in:aDirectory
    "superclass TonelFileUtils class says that I am responsible to implement this method"

    ^ self shouldImplement
!

writeStreamFor: filePath in: aDirectory do: aBlock
     (aDirectory / filePath) writingFileDo: [:s|
        aBlock value: (EncodedStream stream: s encoding: #utf8).
    ].

    "Modified: / 01-02-2021 / 09:46:31 / Jan Vrany <jan.vrany@labware.com>"
! !

!TonelFileUtilsStX class methodsFor:'documentation'!

version_HG

    ^ '$Changeset: <not expanded> $'
! !

