"
COPYRIGHT (c) 2020 LabWare
"
"{ Package: 'stx:goodies/monticello/tonel/tests' }"

"{ NameSpace: Smalltalk }"

MCDirectoryRepositoryTest subclass:#TonelRepositoryTest
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'SCM-Monticello-Tonel-Tests'
!

!TonelRepositoryTest class methodsFor:'documentation'!

copyright
"
COPYRIGHT (c) 2020 LabWare


"
! !

!TonelRepositoryTest methodsFor:'private factory'!

newMemoryFileSystem
    "This method assumes writer works. If it is broken (the tests should show it), this tests 
     will break too."
    | mem |
    mem := self directory.
    (TonelWriter on: mem) writeSnapshot: self mockSnapshot.
    ^ mem

    "Modified: / 03-07-2020 / 20:11:12 / Jan Vrany <jan.vrany@labware.com>"
! !

!TonelRepositoryTest methodsFor:'running'!

setUp
    super setUp.
    repository := TonelRepository new directory: self directory
! !

!TonelRepositoryTest methodsFor:'tests'!

testCanCreateTonelRepositoryFromUrl
    repository := MCRepository fromUrl: (self homeDirectoryUrl scheme: #tonel) asString.
    self assert: (repository isKindOf: TonelRepository).
    
    repository := MCRepository fromUrl: 'tonel://.'.
    self assert: (repository isKindOf: TonelRepository) 
!

testLoadAllFileNames
    | mem |
    
    mem := self newMemoryFileSystem.
    repository := TonelRepository new directory: mem.
    
    self 
        assert: repository allFileNames asArray 
        equals: #('Monticello-Mocks')

    "Modified: / 09-07-2020 / 21:44:21 / Jan Vrany <jan.vrany@labware.com>"
! !

!TonelRepositoryTest class methodsFor:'documentation'!

version_HG

    ^ '$Changeset: <not expanded> $'
! !

